#!/usr/local/bin/lua

-- compute freqeuncy of contacts from a set of contacts maps files

local nkeys = 0
local data = setmetatable({},{__index = function(t,k) rawset(t,k,{}) return rawget(t,k) end})

-- get 'ls -A1'
local osls = function(name)
	local handle = assert(io.popen(string.format('ls -A1 %s',name),'r'))
	local output = assert(handle:read('*a'))
	local returned = {handle:close()}
	return coroutine.wrap( function()
		for file in output:gmatch('(.-)\n') do
			coroutine.yield(file)
		end
	end)
end

local nfiles = 0

for filename in osls(arg[1] or "*.map") do
	print("data: "..filename)
	local file = io.open(filename,'r')
	nfiles = nfiles + 1
	for line in file:lines() do
		if line:find('1 [01] [01] [01]') or line:find('[01] [01] [01] 1') then -- OV or rCSU
			local t = {}
			for k in line:gmatch('(%S+)') do t[#t+1] = k end
			local key1 = string.format('%s_%s_%d',t[4],t[5],t[6])
			local key2 = string.format('%s_%s_%d',t[8],t[9],t[10])
			data[key1][key2] = (data[key1][key2] or 0) + 1
		end
	end
	file:close()
end

for k1,v1 in pairs(data) do
for k2,v2 in pairs(v1) do
	local n1 = math.tointeger(k1:sub(7,#k1))
	local n2 = math.tointeger(k2:sub(7,#k2))
	io.write(string.format('%-15s %-15s %15d %15d',k1,k2,n1,n2))
	local f = 1.0*v2/nfiles -- frequency
	local std = math.sqrt(f*(1-f)/nfiles) -- http://en.wikipedia.org/wiki/Binomial_proportion_confidence_interval
	io.write(string.format('%15.6f %15.6f',f,std))
	print""
end
end
